SoPointSet Class Reference
Node Classes

The SoPointSet class is used to display a set of 3D points. More...

`#include <Inventor/nodes/SoPointSet.h>`

Inheritance diagram for SoPointSet:

## Public Member Functions

virtual SoType | getTypeId (void) const
| SoPointSet (void)
virtual void | GLRender (SoGLRenderAction *action)
virtual void | getBoundingBox (SoGetBoundingBoxAction *action)
virtual void | getPrimitiveCount (SoGetPrimitiveCountAction *action)
Public Member Functions inherited from SoVertexShape
virtual void | notify (SoNotList *nl)
virtual void | write (SoWriteAction *action)
Public Member Functions inherited from SoShape
virtual SbBool | affectsState (void) const
virtual void | rayPick (SoRayPickAction *action)
virtual void | callback (SoCallbackAction *action)
const SoBoundingBoxCache * | getBoundingBoxCache (void) const
Public Member Functions inherited from SoNode
void | setOverride (const SbBool state)
SbBool | isOverride (void) const
void | setNodeType (const NodeType type)
NodeType | getNodeType (void) const
virtual SoNode * | copy (SbBool copyconnections=FALSE) const
virtual void | doAction (SoAction *action)
virtual void | GLRenderBelowPath (SoGLRenderAction *action)
virtual void | GLRenderInPath (SoGLRenderAction *action)
virtual void | GLRenderOffPath (SoGLRenderAction *action)
virtual void | getMatrix (SoGetMatrixAction *action)
virtual void | handleEvent (SoHandleEventAction *action)
virtual void | pick (SoPickAction *action)
virtual void | search (SoSearchAction *action)
virtual void | audioRender (SoAudioRenderAction *action)
virtual void | grabEventsSetup (void)
virtual void | grabEventsCleanup (void)
virtual void | startNotify (void)
SbUniqueId | getNodeId (void) const
virtual SoChildList * | getChildren (void) const
virtual void | writeInstance (SoOutput *out)
virtual SoNode * | addToCopyDict (void) const
virtual void | copyContents (const SoFieldContainer *from, SbBool copyconnections)
virtual SoFieldContainer * | copyThroughConnection (void) const
Public Member Functions inherited from SoFieldContainer
void | setToDefaults (void)
SbBool | hasDefaultValues (void) const
SbBool | fieldsAreEqual (const SoFieldContainer *container) const
void | copyFieldValues (const SoFieldContainer *container, SbBool copyconnections=FALSE)
SbBool | set (const char *const fielddata)
void | get (SbString &fielddata)
virtual int | getFields (SoFieldList &l) const
virtual int | getAllFields (SoFieldList &l) const
virtual SoField * | getField (const SbName &name) const
virtual SoField * | getEventIn (const SbName &name) const
virtual SoField * | getEventOut (const SbName &name) const
SbBool | getFieldName (const SoField *const field, SbName &name) const
SbBool | enableNotify (const SbBool flag)
SbBool | isNotifyEnabled (void) const
SbBool | set (const char *fielddata, SoInput *input)
void | get (SbString &fielddata, SoOutput *out)
virtual SbBool | validateNewFieldValue (SoField *field, void *newval)
virtual void | addWriteReference (SoOutput *out, SbBool isfromfield=FALSE)
SbBool | getIsBuiltIn (void) const
virtual void | getFieldsMemorySize (size_t &managed, size_t &unmanaged) const
void | setUserData (void *userdata) const
void * | getUserData (void) const
Public Member Functions inherited from SoBase
void | ref (void) const
void | unref (void) const
void | unrefNoDelete (void) const
int32_t | getRefCount (void) const
void | touch (void)
SbBool | isOfType (SoType type) const
| Returns `TRUE` if the type of this object is either of the same type or inherited from type.
virtual SbName | getName (void) const
virtual void | setName (const SbName &newname)
void | addAuditor (void *const auditor, const SoNotRec::Type type)
void | removeAuditor (void *const auditor, const SoNotRec::Type type)
const SoAuditorList & | getAuditors (void) const
SbBool | shouldWrite (void)
void | assertAlive (void) const

## Static Public Member Functions

static SoType | getClassTypeId (void)
static void | initClass (void)
Static Public Member Functions inherited from SoNonIndexedShape
static SoType | getClassTypeId (void)
static void | initClass (void)
Static Public Member Functions inherited from SoVertexShape
static SoType | getClassTypeId (void)
static void | initClass (void)
Static Public Member Functions inherited from SoShape
static SoType | getClassTypeId (void)
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static void | getScreenSize (SoState *const state, const SbBox3f &boundingbox, SbVec2s &rectsize)
static float | getDecimatedComplexity (SoState *state, float complexity)
Static Public Member Functions inherited from SoNode
static uint32_t | getCompatibilityTypes (const SoType &nodetype)
static SoType | getClassTypeId (void)
static SoNode * | getByName (const SbName &name)
static int | getByName (const SbName &name, SoNodeList &l)
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static void | initClasses (void)
static SbUniqueId | getNextNodeId (void)
static int | getActionMethodIndex (const SoType type)
static void | getBoundingBoxS (SoAction *action, SoNode *node)
static void | GLRenderS (SoAction *action, SoNode *node)
static void | callbackS (SoAction *action, SoNode *node)
static void | getMatrixS (SoAction *action, SoNode *node)
static void | handleEventS (SoAction *action, SoNode *node)
static void | pickS (SoAction *action, SoNode *node)
static void | rayPickS (SoAction *action, SoNode *node)
static void | searchS (SoAction *action, SoNode *node)
static void | writeS (SoAction *action, SoNode *node)
static void | audioRenderS (SoAction *action, SoNode *node)
static void | getPrimitiveCountS (SoAction *action, SoNode *node)
Static Public Member Functions inherited from SoFieldContainer
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType | getClassTypeId (void)
| This static method returns the SoType object associated with objects of this class.
static void | cleanupClass (void)
static void | initCopyDict (void)
static void | addCopy (const SoFieldContainer *orig, const SoFieldContainer *copy)
static SoFieldContainer * | checkCopy (const SoFieldContainer *orig)
static SoFieldContainer * | findCopy (const SoFieldContainer *orig, const SbBool copyconnections)
static void | copyDone (void)
Static Public Member Functions inherited from SoBase
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType | getClassTypeId (void)
| This static method returns the SoType object associated with objects of this class.
static void | addName (SoBase *const base, const char *const name)
static void | removeName (SoBase *const base, const char *const name)
static void | incrementCurrentWriteCounter (void)
static void | decrementCurrentWriteCounter (void)
static SoBase * | getNamedBase (const SbName &name, SoType type)
static int | getNamedBases (const SbName &name, SoBaseList &baselist, SoType type)
static SbBool | read (SoInput *input, SoBase *&base, SoType expectedtype)
static void | setInstancePrefix (const SbString &c)
static void | setTraceRefs (SbBool trace)
static SbBool | getTraceRefs (void)
static SbBool | connectRoute (SoInput *input, const SbName &fromnodename, const SbName &fromfieldname, const SbName &tonodename, const SbName &tofieldname)
static SbBool | readRoute (SoInput *input)

## Public Attributes

SoSFInt32 | numPoints
Public Attributes inherited from SoNonIndexedShape
SoSFInt32 | startIndex
Public Attributes inherited from SoVertexShape
SoSFNode | vertexProperty

## Protected Member Functions

virtual const SoFieldData * | getFieldData (void) const
virtual | ~SoPointSet ()
virtual void | generatePrimitives (SoAction *action)
virtual void | computeBBox (SoAction *action, SbBox3f &box, SbVec3f &center)
virtual SbBool | generateDefaultNormals (SoState *, SoNormalCache *nc)
virtual SbBool | generateDefaultNormals (SoState *state, SoNormalBundle *bundle)
Protected Member Functions inherited from SoNonIndexedShape
| SoNonIndexedShape (void)
virtual | ~SoNonIndexedShape ()
void | computeCoordBBox (SoAction *action, int numVertices, SbBox3f &box, SbVec3f &center)
void | fixNumVerticesPointers (SoState *state, const int32_t *&start, const int32_t *&end, int32_t *dummyarray) const
Protected Member Functions inherited from SoVertexShape
| SoVertexShape (void)
virtual | ~SoVertexShape ()
virtual SbBool | shouldGLRender (SoGLRenderAction *action)
void | setNormalCache (SoState *const state, const int num, const SbVec3f *normals)
SoNormalCache * | getNormalCache (void) const
SoNormalCache * | generateAndReadLockNormalCache (SoState *const state)
void | getVertexData (SoState *state, const SoCoordinateElement *&coords, const SbVec3f *&normals, const SbBool neednormals)
void | readLockNormalCache (void)
void | readUnlockNormalCache (void)
Protected Member Functions inherited from SoShape
| SoShape (void)
virtual | ~SoShape ()
float | getComplexityValue (SoAction *action)
void | beginSolidShape (SoGLRenderAction *action)
void | endSolidShape (SoGLRenderAction *action)
void | GLRenderBoundingBox (SoGLRenderAction *action)
SbBool | shouldPrimitiveCount (SoGetPrimitiveCountAction *action)
SbBool | shouldRayPick (SoRayPickAction *const action)
void | computeObjectSpaceRay (SoRayPickAction *const action)
void | computeObjectSpaceRay (SoRayPickAction *const action, const SbMatrix &matrix)
virtual SoDetail * | createTriangleDetail (SoRayPickAction *action, const SoPrimitiveVertex *v1, const SoPrimitiveVertex *v2, const SoPrimitiveVertex *v3, SoPickedPoint *pp)
virtual SoDetail * | createLineSegmentDetail (SoRayPickAction *action, const SoPrimitiveVertex *v1, const SoPrimitiveVertex *v2, SoPickedPoint *pp)
virtual SoDetail * | createPointDetail (SoRayPickAction *action, const SoPrimitiveVertex *v, SoPickedPoint *pp)
void | invokeTriangleCallbacks (SoAction *const action, const SoPrimitiveVertex *const v1, const SoPrimitiveVertex *const v2, const SoPrimitiveVertex *const v3)
void | invokeLineSegmentCallbacks (SoAction *const action, const SoPrimitiveVertex *const v1, const SoPrimitiveVertex *const v2)
void | invokePointCallbacks (SoAction *const action, const SoPrimitiveVertex *const v)
void | beginShape (SoAction *const action, const TriangleShape shapetype, SoDetail *const detail=NULL)
void | shapeVertex (const SoPrimitiveVertex *const v)
void | endShape (void)
void | generateVertex (SoPrimitiveVertex *const pv, const SbVec3f &point, const SbBool useTexFunc, const SoMultiTextureCoordinateElement *const tce, const float s, const float t, const SbVec3f &normal)
void | generateVertex (SoPrimitiveVertex *const pv, const SbVec3f &point, const SbBool useTexFunc, const SoMultiTextureCoordinateElement *const tce, const float s, const float t, const float r, const SbVec3f &normal)
SbBool | startVertexArray (SoGLRenderAction *action, const SoCoordinateElement *coords, const SbVec3f *pervertexnormals, const SbBool texpervertex, const SbBool colorpervertex)
void | finishVertexArray (SoGLRenderAction *action, const SbBool vbo, const SbBool normpervertex, const SbBool texpervertex, const SbBool colorpervertex)
Protected Member Functions inherited from SoNode
| SoNode (void)
virtual | ~SoNode ()
virtual SbBool | readInstance (SoInput *in, unsigned short flags)
Protected Member Functions inherited from SoFieldContainer
| SoFieldContainer (void)
virtual | ~SoFieldContainer ()
Protected Member Functions inherited from SoBase
| SoBase (void)
virtual | ~SoBase ()
virtual void | destroy (void)
SbBool | hasMultipleWriteRefs (void) const
SbBool | writeHeader (SoOutput *out, SbBool isgroup, SbBool isengine) const
void | writeFooter (SoOutput *out) const
virtual const char * | getFileFormatName (void) const
virtual SoNotRec | createNotRec (void)

## Static Protected Member Functions

static const SoFieldData ** | getFieldDataPtr (void)
Static Protected Member Functions inherited from SoNonIndexedShape
static const SoFieldData ** | getFieldDataPtr (void)
Static Protected Member Functions inherited from SoVertexShape
static const SoFieldData ** | getFieldDataPtr (void)
Static Protected Member Functions inherited from SoShape
static const SoFieldData ** | getFieldDataPtr (void)
Static Protected Member Functions inherited from SoNode
static const SoFieldData ** | getFieldDataPtr (void)
static void | setNextActionMethodIndex (int index)
static int | getNextActionMethodIndex (void)
static void | incNextActionMethodIndex (void)
static void | setCompatibilityTypes (const SoType &nodetype, const uint32_t bitmask)
Static Protected Member Functions inherited from SoBase
static uint32_t | getCurrentWriteCounter (void)
static void | staticDataLock (void)
static void | staticDataUnlock (void)

## Additional Inherited Members

Public Types inherited from SoShape
enum | TriangleShape { TRIANGLE_STRIP , TRIANGLE_FAN , TRIANGLES , POLYGON , QUADS , QUAD_STRIP , POINTS , LINES , LINE_STRIP }
Public Types inherited from SoNode

enum

NodeType {
INVENTOR = 0x0000 , VRML1 = 0x0001 , VRML2 = 0x0002 , INVENTOR_1 = 0x0004 ,
INVENTOR_2_0 = 0x0008 , INVENTOR_2_1 = 0x0010 , INVENTOR_2_5 = 0x0020 , INVENTOR_2_6 = 0x0040 ,
COIN_1_0 = 0x0080 , COIN_2_0 = 0x0100 , EXTENSION = 0x0200 , COIN_2_2 = 0x0400 ,
COIN_2_3 = 0x0800 , COIN_2_4 = 0x1000 , INVENTOR_5_0 = 0x2000 , COIN_2_5 = 0x4000 ,
COIN_3_0 = 0x8000 , INVENTOR_6_0 = 0x10000 , COIN_4_0 = 0x20000
}

Protected Types inherited from SoBase
enum | BaseFlags { IS_ENGINE = 0x01 , IS_GROUP = 0x02 }
Protected Attributes inherited from SoNode
SbUniqueId | uniqueId
Protected Attributes inherited from SoFieldContainer
SbBool | isBuiltIn
Static Protected Attributes inherited from SoNode
static SbUniqueId | nextUniqueId = 1
static int | nextActionMethodIndex = 0

## Detailed Description

The SoPointSet class is used to display a set of 3D points.

This node either uses the coordinates currently on the state (typically set up by a leading SoCoordinate3 node in the scene graph) or from a SoVertexProperty node attached to this node to render a set of 3D points.

The SoPointSet::numPoints field specifies the number of points in the coordinate set which should be rendered (or otherwise handled by traversal actions).

Here's a simple usage example of SoPointSet in a scene graph:

    #Inventor V2.1 ascii

    Separator {
       Material {
          diffuseColor [
           1 0 0, 0 1 0, 0 0 1, 1 1 0, 1 0 1, 1 1 1, 1 0.8 0.6, 0.6 0.8 1
          ]
       }
       MaterialBinding { value PER_PART }

       Coordinate3 {
          point [
           -1 1 0, -1 -1 0, 1 -1 0, 1 1 0, 0 2 -1, -2 0 -1, 0 -2 -1, 2 0 -1
          ]
       }

       DrawStyle { pointSize 3 }

       PointSet { }
    }

FILE FORMAT/DEFAULTS:

PointSet {
vertexProperty NULL
startIndex 0
numPoints -1
}
SoNonIndexedShape::startIndex
SoSFInt32 startIndex
Definition SoNonIndexedShape.h:49
SoPointSet::numPoints
SoSFInt32 numPoints
Definition SoPointSet.h:49
SoVertexShape::vertexProperty
SoSFNode vertexProperty
Definition SoVertexShape.h:58

## Constructor & Destructor Documentation

## SoPointSet()

SoPointSet::SoPointSet | ( | void |  | ) |

Constructor.

## ~SoPointSet()

SoPointSet::~SoPointSet | ( |  | ) |

protected virtual

Destructor.

## Member Function Documentation

## getClassTypeId()

SoType SoPointSet::getClassTypeId | ( | void |  | ) |

static

This static method returns the SoType object associated with objects of this class.

## getTypeId()

SoType SoPointSet::getTypeId | ( | void |  | ) | const

virtual

Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and "downward" casting.

Reimplemented from SoNonIndexedShape.

Reimplemented in SoMarkerSet.

## getFieldDataPtr()

const SoFieldData ** SoPointSet::getFieldDataPtr | ( | void |  | ) |

static protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
Returns the SoFieldData class which holds information about fields in this node.

## getFieldData()

const SoFieldData * SoPointSet::getFieldData | ( | void |  | ) | const

protected virtual

Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns `NULL`.

Reimplemented from SoNonIndexedShape.

Reimplemented in SoMarkerSet.

## initClass()

void SoPointSet::initClass | ( | void |  | ) |

static

## GLRender()

void SoPointSet::GLRender | ( | SoGLRenderAction * | action | ) |

virtual

Action method for the SoGLRenderAction.

This is called during rendering traversals. Nodes influencing the rendering state in any way or want to throw geometry primitives at OpenGL override this method.

Reimplemented from SoShape.

Reimplemented in SoMarkerSet.

## getBoundingBox()

void SoPointSet::getBoundingBox | ( | SoGetBoundingBoxAction * | action | ) |

virtual

Action method for the SoGetBoundingBoxAction.

Calculates bounding box and center coordinates for node and modifies the values of the action to encompass the bounding box for this node and to shift the center point for the scene more towards the one for this node.

Nodes influencing how geometry nodes calculate their bounding box also override this method to change the relevant state variables.

Reimplemented from SoShape.

## getPrimitiveCount()

void SoPointSet::getPrimitiveCount | ( | SoGetPrimitiveCountAction * | action | ) |

virtual

Action method for the SoGetPrimitiveCountAction.

Calculates the number of triangle, line segment and point primitives for the node and adds these to the counters of the action.

Nodes influencing how geometry nodes calculate their primitive count also override this method to change the relevant state variables.

Reimplemented from SoShape.

Reimplemented in SoMarkerSet.

## generatePrimitives()

void SoPointSet::generatePrimitives | ( | SoAction * | action | ) |

protected virtual

The method implements action behavior for shape nodes for SoCallbackAction. It is invoked from SoShape::callback(). (Subclasses should not override SoNode::callback().)

The subclass implementations uses the convenience methods SoShape::beginShape(), SoShape::shapeVertex(), and SoShape::endShape(), with SoDetail instances, to pass the primitives making up the shape back to the caller.

Implements SoShape.

## computeBBox()

void SoPointSet::computeBBox | ( | SoAction * | action,
|  | SbBox3f & | box,
|  | SbVec3f & | center )

protected virtual

Implemented by SoShape subclasses to let the SoShape superclass know the exact size and weighted center point of the shape's bounding box.

The bounding box and center point should be calculated and returned in the local coordinate system.

The method implements action behavior for shape nodes for SoGetBoundingBoxAction. It is invoked from SoShape::getBoundingBox(). (Subclasses should not override SoNode::getBoundingBox().)

The box parameter sent in is guaranteed to be an empty box, while center is undefined upon function entry.

Implements SoShape.

## generateDefaultNormals() [1/2]

SbBool SoPointSet::generateDefaultNormals | ( | SoState * | state,
|  | SoNormalCache * | cache )

protected virtual

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
Subclasses should override this method to generate default normals using the SoNormalCache class. This is more effective than using SoNormalGenerator. Return `TRUE` if normals were generated, `FALSE` otherwise.

Default method just returns `FALSE`.

This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

Reimplemented from SoVertexShape.

## generateDefaultNormals() [2/2]

SbBool SoPointSet::generateDefaultNormals | ( | SoState * | state,
|  | SoNormalBundle * | bundle )

protected virtual

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
Subclasses should override this method to generate default normals using the SoNormalBundle class. `TRUE` should be returned if normals were generated, `FALSE` otherwise.

Default method returns `FALSE`.

This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

Reimplemented from SoVertexShape.

## Member Data Documentation

## numPoints

SoSFInt32 SoPointSet::numPoints

Used to specify number of points in the point set. Coordinates for the points will be taken from the state stack's set of 3D coordinates, typically set up by a leading SoCoordinate3 node.

If this field is equal to -1 (the default value) all coordinates currently on the state will be rendered or otherwise handled by traversal actions.

SoPointSet inherits the field SoNonIndexedShape::startIndex, which specifies the start index for points from the current state set of coordinates. Please note that this field has been obsoleted, but is still provided for compatibility.

The documentation for this class was generated from the following files:

- SoPointSet.h
- SoPointSet.cpp